# Hide UI Plugin

This unofficial TaleSpire plugin for hiding various parts of the UI. The settings are board specific and restored
on board load. UI elements are togged using Config Editor. Groups are defined in a json file so that additional
groups can be added.

This plugin, like all others, is free but if you want to donate, use: http://LordAshes.ca/TalespireDonate/Donate.php

## Change Log

```
1.0.0: Initial release
```

## Install

Use R2ModMan or similar installer to install this plugin.

## Usage

Press the keyboard shortcut for opening the Hide UI GUI. Change the value to ``True`` or ``False``.

``Cancel`` = Undoes all changes.
``Apply`` = Apply the settings (saving them for future use) but don't exit menu.
``Save`` = Apply the settings (saving them for future use) and exit menu.

Default Shortcut: ``RCTRL``+``U``

Note: Apply does save settings, just like save, the only difference is that the menu is not closed.
This allows toggling of different groups until you find the desired one without having to keep reopening
the Hide UI menu.

## Configuration

The plugin uses a single json configuration file called ``HideUIPluginGroups.json`` with the following
format:
```
{
  "groups": {
    "Compass": {
      "visible": true,
      "members": [
        "CompassPin"
      ]
    },
    "PlayerIcons": {
      "visible": false,
      "members": [
        "#PANEL_ClientList"
      ]
    },
    "ToolsPanel": {
      "visible": false,
      "members": [
        "BTN_AddMarker",
        "ToggleCutBox",
        "UI_Rulers"
      ]
    },
  }
}
```

The groups property contains a dictionary of groups. These are the selection in the Hide UI menu.
Eacjh group has a visible property that denotes the default visibility of the groups when a board
does not have saved setting otherwise. Typically the default is set to true. Each group then has
a list of members. These are all the objects that will be hidden or shown when the group is toggled.
When an object is hidden, all objects under it are also automatically hidden. Similarly when an
object is made visible again, all of the objects under it will also become visible (if they where
before).

This configuration can be expanded to include more groups, break down groups into more specific
groups, remove groups and so on.

To determine the name of a specific object, you can use the Unity Explorer plugin. Once loaded,
use the Object Editor to inspect the build scene. You can then toggle various object on and off
to see what they affect. Once you find the correct heirarachy object that toggles the element or
elements that you are looking for, read the name and add it to a new group. In some cases if the
visual element consits of multiple pieces which are not in a common parent, you may need to list
more than one member (as can be seen, for example, in the ToolsPanel group above). 

## Limitation

While typing True or False, the keyboard strokes are also passed to core TS and potentially
trigger effects. This will be fixed in a future update.